local BrokerPoM = CreateFrame("Frame", nil, UIParent)
local pomname = 0
local pomcharge = 0
local pomhealcount = 0
local pomnotarget = "No PoM active"
Broker_PoMDB = {
	orientation = false,
}
local db = Broker_PoMDB

---
BrokerPoM.Target = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_PoM", {
	label = "PoM", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Holy_PrayerOfMendingtga",
	text = "Init",
	OnTooltipShow = function(PoMtooltip)
	if not PoMtooltip or not PoMtooltip.AddLine then return end
    PoMtooltip:AddLine( BrokerPoM.Target.tooltiptext )
	end,
	OnClick = function(self, btn)
		db.orientation = not db.orientation
	end
})
---
function BrokerPoM:OnEvent(event)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED" and arg10 == "Prayer of Mending") then
		local eventname, sourcename, destname = arg2, arg4, arg7
		
		if (eventname == "SPELL_CAST_SUCCESS") then
			if (sourcename == UnitName("player")) then
				pomname = destname
				self.PoMTime = 30
				pomhealcount = 0
				BrokerPoM:Update()
			else
				if (destname == pomname) then
					self:pomkill()
				end
			end
		end
		
		if (sourcename == UnitName("player")) then
			if (eventname == "SPELL_HEAL") then
				local pomhealed = arg12
				local pomoverhealed = arg13
				local pomeffectiveheal = (pomhealed - pomoverhealed)
				pomhealcount = pomhealcount + pomeffectiveheal
			end
						
			if (eventname == "SPELL_AURA_APPLIED") then
				pomname = destname
				pomcharge = select(4, UnitBuff(destname, "Prayer of Mending"))
				self.PoMTime = 30
			end
			
			if (eventname == "SPELL_AURA_REMOVED") then
				self:pomkill()
			end
			self:Update()
		end
	end
end
---
function BrokerPoM:pomkill()
	BrokerPoM.PoMTime = 0
	BrokerPoM:Update()
end
---
function BrokerPoM:OnUpdate(elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate or 0
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
    local PoMTime = self.PoMTime or 0
    local newPoMTime = PoMTime - elapsed
    self.PoMTime = newPoMTime
    if (self.TimeSinceLastUpdate > 0.1) then
    self:Update()
    self.TimeSinceLastUpdate = 0
  	end
end
---
function BrokerPoM:Update()
	BrokerPoM.Target.tooltiptext = ("Healed: "..pomhealcount)
	local pomcharge = "("..pomcharge..")"
	local pomcooldown = select(2, GetSpellCooldown("Prayer of Mending"))
	if pomcooldown > 1.5 then pomcolor = "ffeda55f" else pomcolor = "ffeeeeee" end
	if (self.PoMTime > -0.5) then
		if (self.PoMTime > 23) then pombar = "....."
		elseif (self.PoMTime > 17) then pombar = "...."
		elseif (self.PoMTime > 11) then pombar = "..."
		elseif (self.PoMTime > 5) then pombar = ".."
		elseif (self.PoMTime > 0) then pombar = "."
		elseif (self.PoMTime > -0.5) then 
			pombar = ""
			pomname = ""
			pomcharge = ""
		end
		rightorientation = format("%s %s %s", pombar, pomname, pomcharge) 
		leftorientation = format("%s %s %s", pomcharge, pomname, pombar) 
		pomtext = db.orientation and rightorientation or leftorientation
		BrokerPoM.Target.text = "|c"..pomcolor..""..pomtext.."|r"
	else
	BrokerPoM.Target.text = "|c"..pomcolor..""..pomnotarget.."|r"
	end
end
---
BrokerPoM:SetScript("OnEvent", BrokerPoM.OnEvent)
BrokerPoM:SetScript("OnUpdate", BrokerPoM.OnUpdate)
---
BrokerPoM:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")


